using UnityEngine;
using System.Collections.Generic;
using Utils;

namespace SplineUtils
{
	[System.Serializable]
	public class CoordStruct 
	{
		public Vector3 position = Vector3.zero;
		public Vector3 rotation = Vector3.zero;

		public CoordStruct( Vector3 pos, Vector3 rot )
		{
			position = pos;
			rotation = rot;
		}

		public CoordStruct( CoordStruct c )
		{
			position = c.position;
			rotation = c.rotation;
		}

		// For non-intersecting polygons
		public static Vector3 ComputeCentroid( List<CoordStruct> vertices )
		{
			float aX = 0.0f;
			float aY = 0.0f;
			float aZ = 0.0f;

			for ( int i = 0; i < vertices.Count; i++ )
			{
				aX += vertices[i].position.x;
				aY += vertices[i].position.y;
				aZ += vertices[i].position.z;
			}

			aX /= vertices.Count;
			aY /= vertices.Count;
			aZ /= vertices.Count;

			return new Vector3( aX, aY, aZ );
		}
	}
}