﻿using UnityEngine;
using System.Collections.Generic;

namespace SplineUtils
{
	public class SplineFollower : MonoBehaviour 
	{
		public bool 					isPlaying = false;
		public SplineController			animatingSplineController;
		public Vector3					globalPosOffset = Vector3.zero;
		public Vector3					globalRotOffset = Vector3.zero;
		[HideInInspector]
		public List<SplineNode>			animatingSpline;

		private Transform				m_t;
		private float					m_time = 0.0f;
		private Vector3					m_velocity;
		private float					m_endTime;

		void Awake()
		{
			m_t = transform;
		}


		/*
		void OnGUI()
		{
			if ( GUI.Button( new Rect( 100, 100, 100, 100 ), "START" ) )
			{
				m_time = 0.0f;
				//SplineInterpolatorMK2.TestCrap();
				animatingSplineController.ForceRecalculate();
				animatingSpline = animatingSplineController.resampledSpline;
				Play();
			}
		}
		*/

		public void Play()
		{
			Play ( 0.0f );
		}


		public void Play( float delay )
		{
			m_endTime = animatingSplineController.SpeedControlClip.keys[ animatingSplineController.SpeedControlClip.length - 1 ].time;
			m_time = -delay;
			isPlaying = true;
		}


		void FixedUpdate()
		{
			if ( isPlaying )
			{
				if ( m_time >= m_endTime )
				{
					isPlaying = false;
					return;
				}

				if ( m_time >= 0.0f ) 
				{
					float t = animatingSplineController.SpeedControlClip.Evaluate( Mathf.Max( 0.0f, m_time ) );

					SplineInterpolatorMK2.SplineEvalData evalData = SplineInterpolatorMK2.EvalAtTime( animatingSpline, t );
					m_t.localPosition = evalData.pos + globalPosOffset;
					m_t.localRotation = Quaternion.Euler( evalData.rot.eulerAngles + globalRotOffset );
				}

				m_time += Time.fixedDeltaTime;
			}
		}
	}
}